#include "lusol.h"

/*--------------------------------------------------------*/
void makeLevel(struct lu_t *h_lu, struct level_t *h_lev,
               struct level_t *d_lev)
{
  int i,j,l;

  int n = h_lu->l.n;
  int *level = (int *) malloc(n*sizeof(int));

  // L
  h_lev->nlevL = 0;
  h_lev->jlevL = (int *) calloc(n,sizeof(int));
  h_lev->ilevL = (int *) calloc(n,sizeof(int));

  h_lev->ilevL[0] = 1;
  for (i=0; i<n; i++)
  {
    l = 0;
    for (j = h_lu->l.ia[i]; j < h_lu->l.ia[i+1]; j++)
      l = max(l, level[h_lu->l.ja[j-1]-1]);

    level[i] = l+1;
    h_lev->ilevL[l+1] ++;
    h_lev->nlevL = max(h_lev->nlevL, l+1);
  }

  for (i=1; i<=h_lev->nlevL; i++)
    h_lev->ilevL[i] += h_lev->ilevL[i-1];

  for (i=0; i<n; i++)
  {
    int *k = &h_lev->ilevL[level[i]-1];
    h_lev->jlevL[(*k)-1] = i+1;
    (*k)++;
  }

  for (i=h_lev->nlevL-1; i>0; i--)
    h_lev->ilevL[i] = h_lev->ilevL[i-1];

  h_lev->ilevL[0] = 1;

  // U
  h_lev->nlevU = 0;
  h_lev->jlevU = (int *) malloc(n*sizeof(int));
  h_lev->ilevU = (int *) calloc(n,sizeof(int));

  h_lev->ilevU[0] = 1;
  for (i=n-1; i>=0; i--)
  {
    l = 0;
    for (j = h_lu->u.ia[i]+1; j < h_lu->u.ia[i+1]; j++)
      l = max(l, level[h_lu->u.ja[j-1]-1]);

    level[i] = l+1;
    h_lev->ilevU[l+1] ++;
    h_lev->nlevU = max(h_lev->nlevU, l+1);
  }

  for (i=1; i<=h_lev->nlevU; i++)
    h_lev->ilevU[i] += h_lev->ilevU[i-1];

  for (i=0; i<n; i++)
  {
    int *k = &h_lev->ilevU[level[i]-1];
    h_lev->jlevU[(*k)-1] = i+1;
    (*k)++;
  }

  for (i=h_lev->nlevU-1; i>0; i--)
    h_lev->ilevU[i] = h_lev->ilevU[i-1];

  h_lev->ilevU[0] = 1;

  free(level);

  // copy level info to device
  d_lev->nlevL = h_lev->nlevL;
  cudaMalloc((void **)&d_lev->jlevL, (size_t)n*sizeof(int));
  cudaMalloc((void **)&d_lev->ilevL, (size_t)(h_lev->nlevL+1)
             *sizeof(int));

  d_lev->nlevU = h_lev->nlevU;
  cudaMalloc((void **)&d_lev->jlevU, (size_t)n*sizeof(int));
  cudaMalloc((void **)&d_lev->ilevU, (size_t)(h_lev->nlevU+1)
             *sizeof(int));

  cudaMemcpy(d_lev->jlevL, h_lev->jlevL, (size_t)n*sizeof(int),
             cudaMemcpyHostToDevice);
  cudaMemcpy(d_lev->ilevL, h_lev->ilevL, (size_t)(h_lev->nlevL+1)
             *sizeof(int), cudaMemcpyHostToDevice);

  //printf("L nlev = %d\n", h_lev->nlevL);
/*
  for (i=0; i<n; i++) printf("%d ", h_lev->jlevL[i]); printf("\n");
  for (i=0; i<h_lev->nlevL+1; i++)
    printf("%d ", h_lev->ilevL[i]);
  printf("\n\n");
*/  
  //printf("U nlev = %d\n", h_lev->nlevU);
/*
  for (i=0; i<n; i++) printf("%d ", h_lev->jlevU[i]); printf("\n");
  for (i=0; i<h_lev->nlevU+1; i++)
    printf("%d ", h_lev->ilevU[i]);
  printf("\n");
*/
  cudaMemcpy(d_lev->jlevU, h_lev->jlevU, (size_t)n*sizeof(int),
             cudaMemcpyHostToDevice);
  cudaMemcpy(d_lev->ilevU, h_lev->ilevU, (size_t)(h_lev->nlevU+1)
             *sizeof(int), cudaMemcpyHostToDevice);
}
